#ifndef _COM_INC_
#define _COM_INC_

#ifndef _WINAPI_INC
#include "winapi.inc"
#endif

#use "ole32.lib"
#use "uuid.lib"

#typedef HRESULT       unsigned int
#typedef LCID          unsigned int
#typedef DISPID        unsigned int
#typedef VARTYPE       unsigned word
#typedef VARIANT_BOOL  word
#typedef SCODE         unsigned int
#typedef BSTR          pointer
#typedef RPC_AUTH_IDENTITY_HANDLE int
//temporary
#typedef IStream       int
#typedef IStorage      int
#typedef IMoniker      int
#typedef ITypeInfo     int
#typedef IRecordInfo   int
#typedef IDropTarget   int
#typedef IDataObject   int
#typedef IOleContainer int
#typedef IOleCommandTarget int

struct GUID // easy struct :)
{
	int x[4];
}
struct CLSID
{
	int x[4];
}
struct IID
{
	int x[4];
}
struct SID
{
	int x[4];
}


struct OLEINPLACEFRAMEINFO
{ 
    UINT   cb; 
    BOOL   fMDIApp; 
    HWND   hwndFrame; 
    HACCEL haccel; 
    UINT   cAccelEntries; 
}

struct BORDERWIDTHS
{
	INT left;
	INT top;
	INT right;
	INT bottom;
}
struct OLEMENUGROUPWIDTHS
{
	int width[6];
}
struct DOCHOSTUIINFO
{
	ULONG cbSize;
	DWORD dwFlags;
	DWORD dwDoubleClick;
	OLECHAR *pchHostCss;
	OLECHAR *pchHostNS;
}
struct DVTARGETDEVICE 
{ 
    DWORD tdSize; 
    WORD  tdDriverNameOffset; 
    WORD  tdDeviceNameOffset; 
    WORD  tdPortNameOffset; 
    WORD  tdExtDevmodeOffset; 
    BYTE  tdData[1]; 
}
struct FORMATETC
{
    CLIPFORMAT      cfFormat;
    DVTARGETDEVICE *ptd;
    DWORD          dwAspect;
    LONG           lindex;
    DWORD          tymed;
}
struct STGMEDIUM 
{ 
    DWORD tymed; 
 //   union
        HBITMAP       hBitmap       [0]; 
        HMETAFILEPICT hMetaFilePict [0]; 
        HENHMETAFILE  hEnhMetaFile  [0];
        HGLOBAL       hGlobal       [0];
        LPWSTR        *lpszFileName [0]; // bug: this adds 4 bytes space
        IStream       *pstm         [0]; // bug: this adds 4 bytes space
        IStorage      *pstg         [1];
//	}
}

struct VARIANT
{
	VARTYPE vt;
	WORD wReserved1;
	WORD wReserved2;
	WORD wReserved3;
//	union
//	{
//		LONGLONG                llval[0];             // VT_I8. 
		LONG                    lVal[0];              // VT_I4.
		unsigned byte           bVal[0];              // VT_UI1.
		word                    iVal[0];              // VT_I2.
		float                   fltVal[0];            // VT_R4.
		DOUBLE                  dblVal[0];            // VT_R8.
		VARIANT_BOOL            boolVal[0];           // VT_BOOL.
//		_VARIANT_BOOL           bool[0];
		SCODE                   scode[0];             // VT_ERROR.
//		CY                      cyVal[0];             // VT_CY.
//		DATE                    date[0];              // VT_DATE.
		BSTR                    bstrVal[0];           // VT_BSTR.
//		IUnknown                *punkVal[0];          // VT_UNKNOWN.
//		IDispatch               *pdispVal[0];         // VT_DISPATCH.
//		SAFEARRAY               *parray[0];           // VT_ARRAY|*.
//		BYTE                    *pbVal[0];            // VT_BYREF|VT_UI1.
//		SHORT                   *piVal[0];            // VT_BYREF|VT_I2.
//		LONG                    *plVal[0];            // VT_BYREF|VT_I4.
//		LONGLONG                *pllVal[0];           // VT_BYREF|VT_I8.
//		FLOAT                   *pfltVal[0];          // VT_BYREF|VT_R4.
//		DOUBLE                  *pdblVal[0];          // VT_BYREF|VT_R8.
//		VARIANT_BOOL            *pboolVal[0];         // VT_BYREF|VT_BOOL.

//		_VARIANT_BOOL           *pbool[0];
//		SCODE                   *pscode[0];           // VT_BYREF|VT_ERROR.
//		CY                      *pcyVal[0];           // VT_BYREF|VT_CY.
//		DATE                    *pdate[0];            // VT_BYREF|VT_DATE.
//		BSTR                    *pbstrVal[0];         // VT_BYREF|VT_BSTR.
//		IUnknown                *ppunkVal[0];         // VT_BYREF|VT_UNKNOWN.
//		IDispatch               *ppdispVal[0];        // VT_BYREF|VT_DISPATCH.
//		SAFEARRAY               *pparray[0];          // VT_ARRAY|*.
//		VARIANT                 *pvarVal[0];          // VT_BYREF|VT_VARIANT.
//		PVOID                   *xbyref[0];           // Generic ByRef.
		byte                    cVal[0];              // VT_I1.
		USHORT                  uiVal[0];             // VT_UI2.
		ULONG                   ulVal[0];             // VT_UI4.
//		ULONGLONG               ullVal[0];            // VT_UI8.
		INT                     intVal[0];            // VT_INT.
		UINT                    uintVal[0];           // VT_UINT.
//		DECIMAL                 *pdecVal[0];          // VT_BYREF|VT_DECIMAL.
//		CHAR                    *pcVal[0];            // VT_BYREF|VT_I1.
//		USHORT                  *puiVal[0];           // VT_BYREF|VT_UI2.
//		ULONG                   *pulVal[0];           // VT_BYREF|VT_UI4.
//		ULONGLONG               *pullVal[0];          // VT_BYREF|VT_UI8.
//		INT                     *pintVal[0];          // VT_BYREF|VT_INT.
//		UINT                    *puintVal[0];         // VT_BYREF|VT_UINT.
//		struct __tagBRECORD
//		{
			PVOID                   pvRecord;
			IRecordInfo             *pRecInfo;
//		}
//	}
//	}
//		DECIMAL decVal;
//	}
}


struct DISPPARAMS
{
	VARIANT      *rgvarg;           // Array of arguments.
	DISPID       *rgdispidNamedArgs;// Dispatch IDs of named arguments.
	Unsigned int cArgs;             // Number of arguments.
 	Unsigned int cNamedArgs;        // Number of named arguments.
}

struct EXCEPINFO
{
   USHORT wCode;      // An error code describing the error.
   USHORT wReserved;
   BSTR bstrSource;            // Source of the exception.
   BSTR bstrDescription;      // Textual description of the error.
   BSTR bstrHelpFile;         // Help file path.
   ULONG dwHelpContext;   // Help context ID.
   Void *pvReserved;
   // Pointer to function that fills in Help and description info.
   void *pfnDeferredFillIn; //HRESULT (STDAPICALLTYPE FAR* pfnDeferredFillIn) (struct tagEXCEPINFO FAR*);
   //RETURN VALUE return value;   // A return value describing the error
}

// IShellLinkDataList Interface
struct DATABLOCK_HEADER
{
    DWORD   cbSize;             // Size of this extra data block
    DWORD   dwSignature;        // signature of this extra data block
}
//dwSignature
#define EXP_DARWIN_ID_SIG       0xA0000006
#define EXP_LOGO3_ID_SIG        0xA0000007

struct EXP_DARWIN_LINK
{
	DATABLOCK_HEADER dbh;
	dstring     szDarwinID[MAX_PATH];  // ANSI darwin ID associated with link
	WCHAR       szwDarwinID[MAX_PATH]; // UNICODE darwin ID associated with link
}

interface IUnknown
{
	declare virtual QueryInterface(GUID *refiid, void *ppv),HRESULT;
	declare virtual AddRef(),HRESULT;
	declare virtual Release(),HRESULT;
}
interface IDispatch : IUnknown
{
	declare virtual GetTypeInfoCount(unsigned int *pctinfo),HRESULT;
	declare virtual GetTypeInfo(unsigned int iTInfo, LCID lcid, ITypeInfo *ppTInfo),HRESULT;
	declare virtual GetIDsOfNames(GUID *riid, OLECHAR *rgszNames, unsigned int cNames, LCID lcid, DISPID *rgDispId),HRESULT;
	declare virtual Invoke(DISPID dispIdMember, GUID *riid, LCID lcid, WORD wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, unsigned int *puArgErr),HRESULT;
}
interface IOleWindow : IUnknown
{
	declare virtual GetWindow(HWND *phwnd),HRESULT;
	declare virtual ContextSensitiveHelp(BOOL fEnterMode),HRESULT;
}
interface IOleInPlaceObject : IOleWindow
{
	declare virtual InPlaceDeactivate(),HRESULT;
	declare virtual UIDeactivate(),HRESULT;
	declare virtual SetObjectRects(RECT *lprcPosRect, RECT *lprcClipRect),HRESULT;
	declare virtual ReactivateAndUndo(),HRESULT;
}
interface IOleInPlaceSite : IOleWindow
{
	declare virtual CanInPlaceActivate(),HRESULT;
	declare virtual OnInPlaceActivate(),HRESULT;
	declare virtual OnUIActivate(),HRESULT;
	declare virtual GetWindowContext(IOleInPlaceFrame *ppFrame, IOleInPlaceUIWindow *ppDoc, RECT *lprcPosRect, RECT *lprcClipRect, OLEINPLACEFRAMEINFO *lpFrameInfo),HRESULT;
	declare virtual Scroll(SIZE *scrollExtant),HRESULT;
	declare virtual OnUIDeactivate(BOOL fUndoable),HRESULT;
	declare virtual OnInPlaceDeactivate(),HRESULT;
	declare virtual DiscardUndoState(),HRESULT;
	declare virtual DeactivateAndUndo(),HRESULT;
	declare virtual OnPosRectChange(RECT *lprcPosRect),HRESULT;
}
interface IOleInPlaceSiteEx : IOleInPlaceSite
{
	declare virtual OnInPlaceActivateEx(BOOL *pfNoRedraw, DWORD dwFlags),HRESULT;
	declare virtual OnInPlaceDeactivateEx(BOOL fNoRedraw),HRESULT;
	declare virtual RequestUIActivate(),HRESULT;
}
interface IOleInPlaceActiveObject : IOleWindow
{
	declare virtual TranslateAccelerator(MSG *lpmsg),HRESULT;
	declare virtual OnFrameWindowActivate(BOOL fActivate),HRESULT;
	declare virtual OnDocWindowActivate(BOOL fActivate),HRESULT;
	declare virtual ResizeBorder(RECT *prcBorder, IOleInPlaceUIWindow *pUIWindow, BOOL fFrameWindow),HRESULT;
	declare virtual EnableModeless(BOOL fEnable),HRESULT;
}
interface IOleInPlaceUIWindow : IOleWindow
{
	declare virtual GetBorder(RECT *lprectBorder),HRESULT;
	declare virtual RequestBorderSpace(BORDERWIDTHS *pborderwidths),HRESULT;
	declare virtual SetBorderSpace(BORDERWIDTHS *pborderwidths),HRESULT;
	declare virtual SetActiveObject(IOleInPlaceActiveObject *pActiveObject, LPCOLESTR *pszObjName),HRESULT;
}
interface IOleInPlaceFrame : IOleInPlaceUIWindow
{
	declare virtual InsertMenus(HMENU hmenuShared, OLEMENUGROUPWIDTHS *lpMenuWidths),HRESULT;
	declare virtual SetMenu(HMENU hmenuShared, HMENU holemenu, HWND hwndActiveObject),HRESULT;
	declare virtual RemoveMenus(HMENU hmenuShared),HRESULT;
	declare virtual SetStatusText(LPCOLESTR *pszStatusText),HRESULT;
	declare virtual EnableModeless(BOOL fEnable),HRESULT;
	declare virtual TranslateAccelerator(MSG *lpmsg, word wID),HRESULT;
}
interface IPropertyNotifySink : IUnknown
{
	declare virtual OnChanged(DISPID dispID),HRESULT;
	declare virtual OnRequestEdit(DISPID dispID),HRESULT;
}
interface IServiceProvider : IUnknown
{
	declare virtual QueryService(GUID *guidService, GUID *refiid, void *ppv),HRESULT;
}
interface IAdviseSink : IUnknown
{
	declare virtual OnDataChange(FORMATETC *pFormatetc, STGMEDIUM *pStgmed);
	declare virtual OnViewChange(DWORD dwAspect, LONG lindex);
	declare virtual OnRename(IMoniker pmk);
	declare virtual OnSave();
	declare virtual OnClose();
}
interface IOleControlSite : IUnknown
{
	declare virtual OnControlInfoChanged(),HRESULT;
	declare virtual LockInPlaceActive(BOOL fLock),HRESULT;
	declare virtual GetExtendedControl(IDispatch *ppDisp),HRESULT;
	declare virtual TransformCoords(POINTL *pPtlHimetric, POINTF *pPtfContainer, DWORD dwFlags),HRESULT;
	declare virtual TranslateAccelerator(MSG *pMsg, DWORD grfModifiers),HRESULT;
	declare virtual OnFocus(BOOL fGotFocus),HRESULT;
	declare virtual ShowPropertyFrame(),HRESULT;
}
interface IOleClientSite : IUnknown
{
	declare virtual SaveObject(),HRESULT;
	declare virtual GetMoniker(DWORD dwAssign, DWORD dwWhichMoniker, IMoniker *ppmk),HRESULT;
	declare virtual GetContainer(IOleContainer *ppContainer),HRESULT;
	declare virtual ShowObject(),HRESULT;
	declare virtual OnShowWindow(BOOL fShow),HRESULT;
	declare virtual RequestNewObjectLayout(),HRESULT;
}
interface IDocHostUIHandler : IUnknown
{
	declare virtual ShowContextMenu(DWORD dwID, POINT *ppt, IUnknown pcmdtReserved, IDispatch pdispReserved),HRESULT;
	declare virtual GetHostInfo(DOCHOSTUIINFO *pInfo),HRESULT;
	declare virtual ShowUI(DWORD dwID, IOleInPlaceActiveObject pActiveObject, IOleCommandTarget pCommandTarget, IOleInPlaceFrame pFrame, IOleInPlaceUIWindow pDoc),HRESULT;
	declare virtual HideUI(),HRESULT;
	declare virtual UpdateUI(),HRESULT;
	declare virtual EnableModeless(BOOL fEnable),HRESULT;
	declare virtual OnDocWindowActivate(BOOL fActivate),HRESULT;
	declare virtual OnFrameWindowActivate(BOOL fActivate),HRESULT;
	declare virtual ResizeBorder(RECT *prcBorder, IOleInPlaceUIWindow pUIWindow, BOOL fRameWindow),HRESULT;
	declare virtual TranslateAccelerator(MSG *lpMsg, GUID *pguidCmdGroup, DWORD nCmdID),HRESULT;
	declare virtual GetOptionKeyPath(LPOLESTR *pchKey, DWORD dw),HRESULT;
	declare virtual GetDropTarget(IDropTarget pDropTarget, IDropTarget *ppDropTarget),HRESULT;
	declare virtual GetExternal(IDispatch *ppDispatch),HRESULT;
	declare virtual TranslateUrl(DWORD dwTranslate, OLECHAR *pchURLIn, OLECHAR *ppchURLOut),HRESULT;
	declare virtual FilterDataObject(IDataObject pDO, IDataObject *ppDORet),HRESULT;
}
interface IDocHostShowUI : IUnknown
{
	declare virtual ShowHelp(HWND hwnd, LPOLESTR *pszHelpFile, UINT uCommand, DWORD dwData, POINT *ptMouse, IDispatch *pDispatchObjectHit),HRESULT;
	declare virtual ShowMessage(HWND hwnd, LPOLESTR *lpstrText, LPOLESTR *lpstrCaption, DWORD dwType, LPOLESTR *lpstrHelpFile, DWORD dwHelpContext, LRESULT *plResult),HRESULT;
}
interface IOleObject : IUnknown
{
	declare virtual SetClientSite(IOleClientSite *pClientSite),HRESULT;
	declare virtual GetClientSite(IOleClientSite *ppClientSite),HRESULT;
	declare virtual SetHostNames(LPCOLESTR *szContainerApp, LPCOLESTR *szContainerObj),HRESULT;
	declare virtual Close(DWORD dwSaveOption),HRESULT;
	declare virtual SetMoniker(DWORD dwWhichMoniker, IMoniker *pmk),HRESULT;
	declare virtual GetMoniker(DWORD dwAssign, DWORD dwWhichMoniker, IMoniker *ppmk),HRESULT;
	declare virtual InitFromData(IDataObject *pDataObject, BOOL fCreation, DWORD dwReserved),HRESULT;
	declare virtual GetClipboardData(DWORD dwReserved, IDataObject *ppDataObject),HRESULT;
	declare virtual DoVerb(LONG iVerb, MSG *lpmsg, IOleClientSite *pActiveSite, LONG lindex, HWND hwndParent, RECT *lprcPosRect),HRESULT;
	declare virtual EnumVerbs(IEnumOleVerb *ppEnumOleVerb),HRESULT;
	declare virtual Update(),HRESULT;
	declare virtual IsUpToDate(),HRESULT;
	declare virtual GetUserClassID(CLSID *pClsid),HRESULT;
	declare virtual GetUserType(DWORD dwFormOfType, LPOLESTR *pszUserType/*IMalloc string, must free()*/),HRESULT;
	declare virtual SetExtent(DWORD dwDrawAspect, SIZEL *psizel),HRESULT;
	declare virtual GetExtent(DWORD dwDrawAspect, SIZEL *psizel),HRESULT;
	declare virtual Advise(IAdviseSink *pAdvSink, DWORD *pdwConnection),HRESULT;
	declare virtual Unadvise(DWORD dwConnection),HRESULT;
	declare virtual EnumAdvise(IEnumSTATDATA *ppenumAdvise),HRESULT;
	declare virtual GetMiscStatus(DWORD dwAspect, DWORD *pdwStatus),HRESULT;
	declare virtual SetColorScheme(LOGPALETTE *pLogpal),HRESULT;
}
interface IPersist : IUnknown
{
	declare virtual GetClassID(CLSID * pClassID),HRESULT;
}
interface IPersistStorage : IPersist
{
	declare virtual IsDirty(),HRESULT;
	declare virtual InitNew(IStorage *pStg),HRESULT;
	declare virtual Load(IStorage *pStg),HRESULT;
	declare virtual Save(IStorage *pStgSave, BOOL fSameAsLoad),HRESULT;
	declare virtual SaveCompleted(IStorage *pStgNew),HRESULT;
	declare virtual HandsOffStorage(),HRESULT;
}
interface IShellLink : IUnknown
{
	declare virtual GetPath(LPSTR *pszFile,int cch,WIN32_FIND_DATA *pfd,DWORD fFlags),HRESULT;
	declare virtual GetIDList(ITEMIDLIST *ppidl),HRESULT;
	declare virtual SetIDList(ITEMIDLIST *pidl),HRESULT;
	declare virtual GetDescription(LPSTR *pszName, int cch),HRESULT;
	declare virtual SetDescription(LPCSTR *pszName),HRESULT;
	declare virtual GetWorkingDirectory(LPSTR *pszDir, int cch),HRESULT;
	declare virtual SetWorkingDirectory(LPCSTR *pszDir),HRESULT;
	declare virtual GetArguments(LPSTR *pszArgs, int cch),HRESULT;
	declare virtual SetArguments(LPCSTR *pszArgs),HRESULT;
	declare virtual GetHotkey(WORD *pwHotkey),HRESULT;
	declare virtual SetHotkey(WORD wHotkey),HRESULT;
	declare virtual GetShowCmd(int *piShowCmd),HRESULT;
	declare virtual SetShowCmd(int iShowCmd),HRESULT;
	declare virtual GetIconLocation(LPSTR *pszIconPath, int cch, int *piIcon),HRESULT;
	declare virtual SetIconLocation(LPCSTR *pszIconPath, int iIcon),HRESULT;
	declare virtual SetRelativePath(LPCSTR *pszPathRel, DWORD dwReserved),HRESULT;
	declare virtual Resolve(HWND hwnd, DWORD fFlags),HRESULT;
	declare virtual SetPath(LPCSTR *pszFile),HRESULT;
}

interface IPersistFile : IPersist
{
	declare virtual IsDirty(),HRESULT;
	declare virtual Load(OLESTR *pszFileName, DWORD dwMode),HRESULT;
	declare virtual Save(OLESTR *pszFileName, BOOL fRemember),HRESULT;
	declare virtual SaveCompleted(OLESTR *pszFileName),HRESULT;
	declare virtual GetCurFile(OLESTR *ppszFileName),HRESULT;
}
interface IShellLinkDataList : IUnknown
{
	declare virtual AddDataBlock(void *pDataBlock),HRESULT;
	declare virtual CopyDataBlock(DWORD dwSig, void *ppDataBlock),HRESULT;
	declare virtual RemoveDataBlock(DWORD dwSig),HRESULT;
	declare virtual GetFlags(DWORD *pdwFlags),HRESULT;
	declare virtual SetFlags(DWORD dwFlags),HRESULT;
}
interface  IWbemLocator : IUnknown
{
	declare virtual ConnectServer( 
            /* [in] */ BSTR *strNetworkResource,
            /* [in] */ BSTR *strUser,
            /* [in] */ BSTR *strPassword,
            /* [in] */ BSTR *strLocale,
            /* [in] */ long lSecurityFlags,
            /* [in] */ BSTR *strAuthority,
            /* [in] */ IWbemContext *pCtx,
            /* [out] */ IWbemServices *ppNamespace),HRESULT;
}
interface IWbemServices : IUnknown
{
	declare virtual OpenNamespace(BSTR *strNamespace, long lFlags, IWbemContext *pCtx, /*out*/ IWbemServices *ppWorkingNamespace, /*out*/ IWbemCallResult *ppResult),HRESULT;
	declare virtual CancelAsyncCall(IWbemObjectSink *pSink),HRESULT;
	declare virtual QueryObjectSink(long lFlags, /*out*/ IWbemObjectSink *ppResponseHandler),HRESULT;
	declare virtual GetObject(BSTR *strObjectPath, long lFlags, IWbemContext *pCtx, /*out*/ IWbemClassObject *ppObject, /*out*/ IWbemCallResult *ppCallResult),HRESULT;
	declare virtual GetObjectAsync(BSTR *strObjectPath, long lFlags, IWbemContext *pCtx, IWbemObjectSink *pResponseHandler),HRESULT;
	declare virtual PutClass(IWbemClassObject *pObject, long lFlags, IWbemContext *pCtx, /*out*/ IWbemCallResult *ppCallResult),HRESULT;
	declare virtual PutClassAsync(IWbemClassObject *pObject, long lFlags, IWbemContext *pCtx, IWbemObjectSink *pResponseHandler),HRESULT;
	declare virtual DeleteClass(BSTR *strClass, long lFlags, IWbemContext *pCtx, /*out*/ IWbemCallResult *ppCallResult),HRESULT;
	declare virtual DeleteClassAsync(BSTR *strClass, long lFlags, IWbemContext *pCtx, IWbemObjectSink *pResponseHandler),HRESULT;
	declare virtual CreateClassEnum(BSTR *strSuperclass, long lFlags, IWbemContext *pCtx, /*out*/ IEnumWbemClassObject *ppEnum),HRESULT;
	declare virtual CreateClassEnumAsync(BSTR *strSuperclass,long lFlags,IWbemContext *pCtx, IWbemObjectSink *pResponseHandler),HRESULT;
	declare virtual PutInstance(IWbemClassObject *pInst,long lFlags,IWbemContext *pCtx,/*out*/ IWbemCallResult *ppCallResult),HRESULT;
	declare virtual PutInstanceAsync(IWbemClassObject *pInst,long lFlags,IWbemContext *pCtx,IWbemObjectSink *pResponseHandler),HRESULT;
	declare virtual DeleteInstance(BSTR *strObjectPath,long lFlags,IWbemContext *pCtx,/*out*/ IWbemCallResult *ppCallResult),HRESULT;
	declare virtual DeleteInstanceAsync(BSTR *strObjectPath,long lFlags,IWbemContext *pCtx,IWbemObjectSink *pResponseHandler),HRESULT;
	declare virtual CreateInstanceEnum(BSTR *strFilter,long lFlags,IWbemContext *pCtx,/*out*/ IEnumWbemClassObject *ppEnum),HRESULT;
	declare virtual CreateInstanceEnumAsync(BSTR *strFilter,long lFlags,IWbemContext *pCtx,IWbemObjectSink *pResponseHandler),HRESULT;
	declare virtual ExecQuery(BSTR *strQueryLanguage,BSTR *strQuery,long lFlags,IWbemContext *pCtx,/*out*/ IEnumWbemClassObject *ppEnum),HRESULT;
	declare virtual ExecQueryAsync(BSTR *strQueryLanguage,BSTR *strQuery,long lFlags,IWbemContext *pCtx,IWbemObjectSink *pResponseHandler),HRESULT;
	declare virtual ExecNotificationQuery(BSTR *strQueryLanguage,BSTR *strQuery,long lFlags,IWbemContext *pCtx,/*out*/ IEnumWbemClassObject *ppEnum),HRESULT;
	declare virtual ExecNotificationQueryAsync(BSTR *strQueryLanguage,BSTR *strQuery,long lFlags,IWbemContext *pCtx,IWbemObjectSink *pResponseHandler),HRESULT;
	declare virtual ExecMethod(BSTR *strObjectPath,BSTR *strMethodName,long lFlags,IWbemContext *pCtx,IWbemClassObject *pInParams,/*out*/ IWbemClassObject *ppOutParams,/*out*/ IWbemCallResult *ppCallResult),HRESULT;
	declare virtual ExecMethodAsync(BSTR *strObjectPath,BSTR *strMethodName,long lFlags,IWbemContext *pCtx,IWbemClassObject *pInParams,IWbemObjectSink *pResponseHandler),HRESULT;
}
interface IEnumWbemClassObject : IUnknown
{
	declare	virtual Reset(),HRESULT;
	declare	virtual Next(long lTimeout,ULONG uCount,/*out*/ IWbemClassObject *apObjects,/*out*/ ULONG *puReturned),HRESULT;
	declare	virtual NextAsync(ULONG uCount,IWbemObjectSink *pSink),HRESULT;
	declare	virtual Clone(/*out*/ IEnumWbemClassObject *ppEnum),HRESULT;
	declare	virtual Skip(long lTimeout,ULONG nCount),HRESULT;
}
interface IWbemClassObject : IUnknown
{
	declare virtual GetQualifierSet(/*out*/ IWbemQualifierSet *ppQualSet),HRESULT;
	declare virtual Get(LPCWSTR *wszName,long lFlags,/*out*/ VARIANT *pVal,/*out*/ CIMTYPE *pType,/*out*/ long *plFlavor),HRESULT;
	declare virtual Put(LPCWSTR *wszName,long lFlags,VARIANT *pVal,CIMTYPE Type),HRESULT;
	declare virtual _delete(LPCWSTR *wszName),HRESULT;
	declare virtual GetNames(LPCWSTR *wszQualifierName,long lFlags,VARIANT *pQualifierVal,/*out*/ SAFEARRAY *pNames),HRESULT;
	declare virtual BeginEnumeration(long lEnumFlags),HRESULT;
	declare virtual Next(long lFlags,/*out*/ BSTR *strName,/*out*/ VARIANT *pVal,/*out*/ CIMTYPE *pType,/*out*/ long *plFlavor),HRESULT;
	declare virtual EndEnumeration(),HRESULT;
	declare virtual GetPropertyQualifierSet(LPCWSTR *wszProperty,/*out*/ IWbemQualifierSet *ppQualSet),HRESULT;
	declare virtual Clone(/*out*/ IWbemClassObject *ppCopy),HRESULT;
	declare virtual GetObjectText(long lFlags,/*out*/ BSTR *pstrObjectText),HRESULT;
	declare virtual SpawnDerivedClass(long lFlags,/*out*/ IWbemClassObject *ppNewClass),HRESULT;
	declare virtual SpawnInstance(long lFlags,/*out*/ IWbemClassObject *ppNewInstance),HRESULT;
	declare virtual CompareTo(long lFlags,IWbemClassObject *pCompareTo),HRESULT;
	declare virtual GetPropertyOrigin(LPCWSTR *wszName,/*out*/ BSTR *pstrClassName),HRESULT;
	declare virtual InheritsFrom(LPCWSTR strAncestor),HRESULT;
	declare virtual GetMethod(LPCWSTR *wszName,long lFlags,/*out*/ IWbemClassObject *ppInSignature,/*out*/ IWbemClassObject *ppOutSignature),HRESULT;
	declare virtual PutMethod(LPCWSTR *wszName,long lFlags,IWbemClassObject *pInSignature,IWbemClassObject *pOutSignature),HRESULT;
	declare virtual DeleteMethod(LPCWSTR *wszName),HRESULT;
	declare virtual BeginMethodEnumeration(long lEnumFlags),HRESULT;
	declare virtual NextMethod(long lFlags,/*out*/ BSTR *pstrName,/*out*/ IWbemClassObject *ppInSignature,/*out*/ IWbemClassObject *ppOutSignature),HRESULT;
	declare virtual EndMethodEnumeration(),HRESULT;
	declare virtual GetMethodQualifierSet(LPCWSTR *wszMethod,/*out*/ IWbemQualifierSet *ppQualSet),HRESULT;
	declare virtual GetMethodOrigin(LPCWSTR *wszMethodName,/*out*/ BSTR *pstrClassName),HRESULT;
}

extern _CLSID_WbemLocator as GUID;
extern _IID_IWbemLocator as GUID;
extern _IID_IShellLinkDataList as GUID;
extern _IID_IPersistFile as GUID;
extern _IID_IPersist as GUID;
extern _IID_IShellLinkA as GUID;
extern _CLSID_ShellLink as GUID;
extern _IID_IUnknown as GUID;
extern _IID_IDispatch as GUID;
extern _IID_IDocHostUIHandler as GUID;
extern _IID_IAdviseSink as GUID;
extern _IID_IDocHostShowUI as GUID;
extern _IID_IOleClientSite as GUID;
extern _IID_IOleControlSite as GUID;
extern _IID_IOleInPlaceFrame as GUID;
extern _IID_IOleInPlaceSite as GUID;
extern _IID_IOleInPlaceSiteEx as GUID;
extern _IID_IOleInPlaceUIWindow as GUID;
extern _IID_IOleWindow as GUID;
extern _IID_IPropertyNotifySink as GUID;
extern _IID_IServiceProvider as GUID;
extern _IID_IOleInPlaceObject as GUID;
extern _IID_IOleObject as GUID;
extern _IID_IPersistStorage as GUID;

#define S_OK   0
#define S_FALSE1
#define E_NOTIMPL      0x80004001
#define E_NOINTERFACE  0x80004002
#define E_POINTER      0x80004003
#define E_OUTOFMEMORY  0x8007000E
#define E_UNEXPECTED   0x8000FFFF
#define E_INVALIDARG   0x80070057
#define DISP_E_UNKNOWNINTERFACE      0x80020001
#define DISP_E_MEMBERNOTFOUND0x80020003
#define DOCHOSTUIFLAG_FLAT_SCROLLBAR 0x80
#define DOCHOSTUIDBLCLK_DEFAULT      0
#define OLECLOSE_NOSAVE  1
//IPersistFile::Load
#define STGM_READ             0x00000000
#define STGM_WRITE            0x00000001
#define STGM_READWRITE        0x00000002
#define STGM_SHARE_DENY_NONE  0x00000040
#define STGM_SHARE_DENY_READ  0x00000030
#define STGM_SHARE_DENY_WRITE 0x00000020
#define STGM_SHARE_EXCLUSIVE  0x00000010
#define STGM_PRIORITY         0x00040000
#define STGM_CREATE           0x00001000
#define STGM_CONVERT          0x00020000
#define STGM_FAILIFTHERE      0x00000000
#define STGM_DIRECT           0x00000000
#define STGM_TRANSACTED       0x00010000
#define STGM_NOSCRATCH        0x00100000
#define STGM_NOSNAPSHOT       0x00200000
#define STGM_SIMPLE           0x08000000
#define STGM_DIRECT_SWMR      0x00400000
#define STGM_DELETEONRELEASE  0x04000000
//IShellLinkDataList::SetFlags
#define SLDF_HAS_ID_LIST         0x00000001   // Shell link saved with ID list
#define SLDF_HAS_LINK_INFO       0x00000002   // Shell link saved with LinkInfo
#define SLDF_HAS_NAME            0x00000004
#define SLDF_HAS_RELPATH         0x00000008
#define SLDF_HAS_WORKINGDIR      0x00000010
#define SLDF_HAS_ARGS            0x00000020
#define SLDF_HAS_ICONLOCATION    0x00000040
#define SLDF_UNICODE             0x00000080   // the strings are unicode
#define SLDF_FORCE_NO_LINKINFO   0x00000100   // don't create a LINKINFO (make a dumb link)
#define SLDF_HAS_EXP_SZ          0x00000200   // the link contains expandable env strings
#define SLDF_RUN_IN_SEPARATE     0x00000400   // Run the 16-bit target exe in a separate VDM/WOW
#define SLDF_HAS_LOGO3ID         0x00000800   // this link is a special Logo3/MSICD link
#define SLDF_HAS_DARWINID        0x00001000   // this link is a special Darwin link
#define SLDF_RUNAS_USER          0x00002000   // Run this link as a different user
#define SLDF_HAS_EXP_ICON_SZ     0x00004000   // contains expandable env string for icon path
#define SLDF_NO_PIDL_ALIAS       0x00008000   // don't ever resolve to a logical location
#define SLDF_FORCE_UNCNAME       0x00010000   // make GetPath() prefer the UNC name to the local name
#define SLDF_RUN_WITH_SHIMLAYER  0x00020000   // Launch the target of this link w/ shim layer active
#define SLDF_RESERVED            0x80000000   // Reserved-- so we can use the low word as an index value in the future
//IShellLink::GetPath
#define SLGP_SHORTPATH   0x1
#define SLGP_UNCPRIORITY 0x2
#define SLGP_RAWPATH     0x4


const OLEIVERB_INPLACEACTIVATE = -5;
#define OLEIVERB_SHOW    -1
#define OLEIVERB_UIACTIVATE      -4

// temporary OLEMISC
#define OLEMISC_RECOMPOSEONRESIZE    1 
#define OLEMISC_ONLYICONIC   2 
#define OLEMISC_INSERTNOTREPLACE     4 
#define OLEMISC_STATIC       8 
#define OLEMISC_CANTLINKINSIDE       16 
#define OLEMISC_CANLINKBYOLE132 
#define OLEMISC_ISLINKOBJECT 64 
#define OLEMISC_INSIDEOUT    128 
#define OLEMISC_ACTIVATEWHENVISIBLE  256 
#define OLEMISC_RENDERINGISDEVICEINDEPENDENT 512 
#define OLEMISC_INVISIBLEATRUNTIME   1024 
#define OLEMISC_ALWAYSRUN    2048 
#define OLEMISC_ACTSLIKEBUTTON       4096 
#define OLEMISC_ACTSLIKELABEL8192 
#define OLEMISC_NOUIACTIVATE 16384 
#define OLEMISC_ALIGNABLE    32768 
#define OLEMISC_SIMPLEFRAME  65536 
#define OLEMISC_SETCLIENTSITEFIRST   131072 
#define OLEMISC_IMEMODE      262144 
#define OLEMISC_IGNOREACTIVATEWHENVISIBLE    524288 
#define OLEMISC_WANTSTOMENUMERGE     1048576 
#define OLEMISC_SUPPORTSMULTILEVELUNDO       2097152 

declare import, SHGetPathFromIDList alias SHGetPathFromIDListA(ITEMIDLIST *pidl,LPTSTR *pszPath),BOOL;
declare import, SHGetPathFromIDListW(ITEMIDLIST *pidl,LPTSTR *pszPath),BOOL;
declare import, CoInitialize(void pvReserved),HRESULT;
declare import, CoInitializeEx(void *pvReserved,DWORD dwCoInit),HRESULT;
#define COINIT_MULTITHREADED     0x0
#define COINIT_APARTMENTTHREADED 0x2
#define COINIT_DISABLE_OLE1DDE   0x4
#define COINIT_SPEED_OVER_MEMORY 0x8
declare import, VariantInit(VARIANT *pvarg);
declare import, VariantClear(VARIANT *pvarg),HRESULT;
declare import, SysAllocString(OLECHAR *sz),BSTR;
declare import, SysFreeString(BSTR  bstr);
declare import, CoUninitialize();
declare import, CoCreateInstance(GUID *rclsid, IUnknown *pUnkOuter, DWORD dwClsContext, GUID *riid, void *ppv),HRESULT;
Declare import, OleRun(IUnknown *pUnknown),WINOLEAPI;
declare import, OleSetMenuDescriptor( 
  HOLEMENU holemenu,      //Handle to the composite menu descriptor
  HWND hwndFrame, //Handle to the container's frame window
  HWND hwndActiveObject,  //Handle to the object's in-place activation window
  IOleInPlaceFrame *lpFrame,  //Pointer to the container's frame window
  IOleInPlaceActiveObject *lpActiveObj //Active in-place object
),WINOLEAPI;

declare import, CoSetProxyBlanket(
  IUnknown *pProxy,
  DWORD dwAuthnSvc,
  DWORD dwAuthzSvc,
  WCHAR *pServerPrincName,
  DWORD dwAuthnLevel,
  DWORD dwImpLevel,
  RPC_AUTH_IDENTITY_HANDLE pAuthInfo,
  DWORD dwCapabilities
),HRESULT;

declare import, CoInitializeSecurity(
  SECURITY_DESCRIPTOR *pVoid,
  LONG cAuthSvc,
  SOLE_AUTHENTICATION_SERVICE *asAuthSvc, 
  void * pReserved1,
  DWORD dwAuthnLevel,
  DWORD dwImpLevel,
  SOLE_AUTHENTICATION_LIST *pAuthList,
  DWORD dwCapabilities,
  void *pReserved3
),HRESULT;
//typedef enum EOLE_AUTHENTICATION_CAPABILITIES
#define EOAC_NONE	 0
#define EOAC_MUTUAL_AUTH	 0x1
#define EOAC_STATIC_CLOAKING	 0x20
#define EOAC_DYNAMIC_CLOAKING	 0x40
#define EOAC_ANY_AUTHORITY	 0x80
#define EOAC_MAKE_FULLSIC	 0x100
#define EOAC_DEFAULT	 0x800
#define EOAC_SECURE_REFS	 0x2
#define EOAC_ACCESS_CONTROL	 0x4
#define EOAC_APPID	 0x8
#define EOAC_DYNAMIC	 0x10
#define EOAC_REQUIRE_FULLSIC	 0x200
#define EOAC_AUTO_IMPERSONATE	 0x400
#define EOAC_NO_CUSTOM_MARSHAL	 0x2000
#define EOAC_DISABLE_AAA	 0x1000

#define RPC_C_AUTHZ_NONE    0
#define RPC_C_AUTHZ_NAME    1
#define RPC_C_AUTHZ_DCE     2
#define RPC_C_AUTHZ_DEFAULT 0xffffffff

#define RPC_C_AUTHN_LEVEL_DEFAULT       0
#define RPC_C_AUTHN_LEVEL_NONE          1
#define RPC_C_AUTHN_LEVEL_CONNECT       2
#define RPC_C_AUTHN_LEVEL_CALL          3
#define RPC_C_AUTHN_LEVEL_PKT           4
#define RPC_C_AUTHN_LEVEL_PKT_INTEGRITY 5
#define RPC_C_AUTHN_LEVEL_PKT_PRIVACY   6

#define RPC_C_IMP_LEVEL_DEFAULT      0
#define RPC_C_IMP_LEVEL_ANONYMOUS    1
#define RPC_C_IMP_LEVEL_IDENTIFY     2
#define RPC_C_IMP_LEVEL_IMPERSONATE  3
#define RPC_C_IMP_LEVEL_DELEGATE     4

#define RPC_C_AUTHN_NONE          0
#define RPC_C_AUTHN_DCE_PRIVATE   1
#define RPC_C_AUTHN_DCE_PUBLIC    2
#define RPC_C_AUTHN_DEC_PUBLIC    4
#define RPC_C_AUTHN_GSS_NEGOTIATE 9
#define RPC_C_AUTHN_WINNT        10
#define RPC_C_AUTHN_GSS_SCHANNEL 14
#define RPC_C_AUTHN_GSS_KERBEROS 16
#define RPC_C_AUTHN_DPA          17
#define RPC_C_AUTHN_MSN          18
#define RPC_C_AUTHN_DIGEST       21
#define RPC_C_AUTHN_MQ          100
#define RPC_C_AUTHN_DEFAULT     0xFFFFFFFF 

//typedef enum CLSCTX
#define CLSCTX_INPROC_SERVER         0x1
#define CLSCTX_INPROC_HANDLER        0x2
#define CLSCTX_LOCAL_SERVER          0x4
#define CLSCTX_INPROC_SERVER16       0x8
#define CLSCTX_REMOTE_SERVER         0x10
#define CLSCTX_INPROC_HANDLER16      0x20
#define CLSCTX_RESERVED1             0x40
#define CLSCTX_RESERVED2             0x80
#define CLSCTX_RESERVED3             0x100
#define CLSCTX_RESERVED4             0x200
#define CLSCTX_NO_CODE_DOWNLOAD      0x400
#define CLSCTX_RESERVED5             0x800
#define CLSCTX_NO_CUSTOM_MARSHAL     0x1000
#define CLSCTX_ENABLE_CODE_DOWNLOAD  0x2000
#define CLSCTX_NO_FAILURE_LOG        0x4000
#define CLSCTX_DISABLE_AAA           0x8000
#define CLSCTX_ENABLE_AAA            0x10000
#define CLSCTX_FROM_DEFAULT_CONTEXT  0x20000
#define CLSCTX_SERVER  21

//typedef enum WBEM_GENERIC_FLAG_TYPE
#define WBEM_FLAG_RETURN_IMMEDIATELY	 0x10
#define WBEM_FLAG_RETURN_WBEM_COMPLETE	 0
#define WBEM_FLAG_BIDIRECTIONAL	 0
#define WBEM_FLAG_FORWARD_ONLY	 0x20
#define WBEM_FLAG_NO_ERROR_OBJECT	 0x40
#define WBEM_FLAG_RETURN_ERROR_OBJECT	 0
#define WBEM_FLAG_SEND_STATUS	 0x80
#define WBEM_FLAG_DONT_SEND_STATUS	 0
#define WBEM_FLAG_ENSURE_LOCATABLE	 0x100
#define WBEM_FLAG_DIRECT_READ	 0x200
#define WBEM_FLAG_SEND_ONLY_SELECTED	 0
#define WBEM_RETURN_WHEN_COMPLETE	 0
#define WBEM_RETURN_IMMEDIATELY	 0x10
#define WBEM_MASK_RESERVED_FLAGS	 0x1f000
#define WBEM_FLAG_USE_AMENDED_QUALIFIERS	 0x20000
#define WBEM_FLAG_STRONG_VALIDATION	 0x100000

//typedef enum tag_WBEM_TIMEOUT_TYPE
#define WBEM_NO_WAIT 0
#define WBEM_INFINITE 0xffffffff

//enum VARENUM                  <- VARIANT.vt
const VT_EMPTY	= 0;
const VT_NULL	= 1;

const VT_BOOL	= 11;
const VT_I1	= 16;
const VT_I2	= 2;
const VT_I4	= 3;
const VT_I8	= 20;
const VT_INT	= 22;
const VT_INT_PTR	= 37;

const VT_UI1	= 17;
const VT_UI2	= 18;
const VT_UI4	= 19;
const VT_UI8	= 21;
const VT_UINT	= 23;
const VT_UINT_PTR	= 38;

const VT_R4	= 4;
const VT_R8	= 5;

const VT_CY	= 6;
const VT_DATE	= 7;
const VT_BSTR	= 8;
const VT_DISPATCH	= 9;
const VT_ERROR	= 10;
const VT_VARIANT	= 12;
const VT_UNKNOWN	= 13;
const VT_DECIMAL	= 14;
const VT_VOID	= 24;
const VT_HRESULT	= 25;
const VT_PTR	= 26;
const VT_SAFEARRAY	= 27;
const VT_CARRAY	= 28;
const VT_USERDEFINED	= 29;
const VT_LPSTR	= 30;
const VT_LPWSTR	= 31;
const VT_RECORD	= 36;
const VT_FILETIME	= 64;
const VT_BLOB	= 65;
const VT_STREAM	= 66;
const VT_STORAGE	= 67;
const VT_STREAMED_OBJECT	= 68;
const VT_STORED_OBJECT	= 69;
const VT_BLOB_OBJECT	= 70;
const VT_CF	= 71;
const VT_CLSID	= 72;
const VT_VERSIONED_STREAM	= 73;
const VT_BSTR_BLOB	= 0xfff;
const VT_VECTOR	= 0x1000;
const VT_ARRAY	= 0x2000;
const VT_BYREF	= 0x4000;
const VT_RESERVED	= 0x8000;
const VT_ILLEGAL	= 0xffff;
const VT_ILLEGALMASKED	= 0xfff;
const VT_TYPEMASK	= 0xfff;
#endif

